IF EXISTS 
(
  SELECT name FROM sysobjects
  WHERE name = 'OM_Ask_SQL' AND type = 'TR'
)
DROP TRIGGER OM_Ask_SQL

GO

CREATE TRIGGER [dbo].[OM_Ask_SQL]
   ON  [dbo].[OM - Ask SQL]
   AFTER INSERT
AS
BEGIN
  SET NOCOUNT ON

  DECLARE @Question INTEGER;
  DECLARE @Answer NVARCHAR(100);

  SELECT @Question = Question
  FROM inserted;

  SET @Answer = '';

  IF @Question = 1
  BEGIN
  SET @Answer = '001';
  END;

  IF @Question = 2
  BEGIN

    SET @Answer = '1';

    DELETE FROM [OM - Where Used Status];

    INSERT INTO [OM - Where Used Status] ([Object Type], [Object No_])
    SELECT ob.[Type], ob.ID
    FROM [Object] ob
      LEFT OUTER JOIN [OM - Known Object Export Error] ee
        ON ob.[Type] = ee.[Object Type]
        AND ob.ID = ee.[Object No_]
      LEFT OUTER JOIN [OM - Where Used Object] wu
        ON ob.[Type] = wu.[Object Type]
        AND ob.ID = wu.[Object No_]
      LEFT OUTER JOIN
      (
        SELECT ho2.[Object Type], ho2.[Object No_], MAX(ho2.[Entry No_]) [Entry No_]
        FROM [OM - C_AL History Object] ho2
        GROUP BY ho2.[Object Type], ho2.[Object No_]
      ) sho
        ON ob.[Type] = sho.[Object Type]
        AND ob.ID = sho.[Object No_]
      LEFT OUTER JOIN [OM - C_AL History Object] ho
        ON sho.[Entry No_] = ho.[Entry No_]
        AND ob.[Type] = ho.[Object Type]
        AND ob.ID = ho.[Object No_]
    WHERE ob.[Type] <> 0
    AND ob.[BLOB Size] > 0
    AND ee.[Object Type] IS NULL
    AND
    (
      wu.[Object Type] IS NULL OR
      wu.[C_AL Changed] = 1 OR
      wu.[Status] < 2 OR
      wu.[Version No_] < 701 OR
      ho.[Entry No_] IS NULL OR
      REPLACE(REPLACE(REPLACE(ho.[Version List], ',', ''), '#', ''), 'LOCKED', '') <>
      REPLACE(REPLACE(REPLACE(ob.[Version List], ',', ''), '#', ''), 'LOCKED', '') OR
      ho.Modified <> ob.Modified OR
      ho.[Object Name] <> ob.Name OR
      ho.[Object Date] <> ob.Date OR
      ABS(CAST(ho.[Object Time] AS FLOAT) - cast(ob.[Time] AS FLOAT)) * 60 * 60 * 24 > 1 OR
      wu.[Object Date] <> ob.Date OR
      wu.[Object Time] <> ob.Time OR
      wu.[Object Modified] <> ob.Modified
    );

    INSERT INTO [OM - Where Used Status] ([Object Type], [Object No_])
    SELECT wu.[Object Type], wu.[Object No_]
    FROM [OM - Where Used Object] wu
      LEFT OUTER JOIN [Object] ob
        ON wu.[Object Type] = ob.[Type]
        AND wu.[Object No_] = ob.ID
    WHERE wu.[Object No_] < 2000000000
    AND ob.[Type] IS NULL;

    SELECT TOP 1 @Answer = '0'
    FROM [OM - Where Used Status];

  END;

  UPDATE [OM - Ask SQL] SET Answer = @Answer
  FROM inserted i, [OM - Ask SQL] ASql
  WHERE i.Question = ASql.Question;

END;
