IF EXISTS 
(
  SELECT name FROM sysobjects
  WHERE name = 'OM_Update_Object' AND type = 'TR'
)
DROP TRIGGER OM_Update_Object

GO

CREATE TRIGGER [dbo].[OM_Update_Object]
   ON  [dbo].[OM - Update Object]
   AFTER INSERT,DELETE,UPDATE
AS 
BEGIN
  SET NOCOUNT ON;

  UPDATE [Object]
  SET [Object].[ID] = Inserted.[New Object No_]
  FROM [Object], Inserted
  WHERE [Object].[Type] = Inserted.[Object Type]
  AND [Object].[ID] = Inserted.[Object No_]
  AND Inserted.[Update Properties] = 0;

  UPDATE [Object]
  SET
    [Object].[ID] = Inserted.[New Object No_],
    [Object].[Modified] = Inserted.[Modified],
    [Object].[Version List] = Inserted.[Version List],
    [Object].[Date] = Inserted.[Object Date],
    [Object].[Time] = Inserted.[Object Time]
  FROM [Object], Inserted
  WHERE [Object].[Type] = Inserted.[Object Type]
  AND [Object].[ID] = Inserted.[Object No_]
  AND Inserted.[Update Properties] = 1;

  DELETE FROM [OM - Update Object] WHERE [Object Type] = -1;

END;
